using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Grouping;

namespace GGC_DataTable
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridGroupingControl1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridGroupingControl1 = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridGroupingControl1
			// 
			this.gridGroupingControl1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.gridGroupingControl1.BackColor = System.Drawing.SystemColors.Window;
			this.gridGroupingControl1.Location = new System.Drawing.Point(24, 24);
			this.gridGroupingControl1.Name = "gridGroupingControl1";
			this.gridGroupingControl1.Size = new System.Drawing.Size(568, 360);
			this.gridGroupingControl1.TabIndex = 0;
			this.gridGroupingControl1.Text = "gridGroupingControl1";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(616, 406);
			this.Controls.Add(this.gridGroupingControl1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			DataSet ds = new DataSet();
			DataTable dtParent = GetParentTable();
			DataTable dtChild = GetChildTable();

			ds.Tables.Add(dtParent);
			ds.Tables.Add(dtChild);
			ds.Relations.Add("Parent_Child",ds.Tables[0].Columns["ParentID"],ds.Tables[1].Columns["ParentID"]);      
			
			this.gridGroupingControl1.DataSource = ds.Tables[0];

			this.gridGroupingControl1.TableControlMoveCurrentCellDirection += new GridTableControlMoveCurrentCellDirectionEventHandler(gridGroupingControl1_TableControlMoveCurrentCellDirection);
		}

		#region DataTable.
		private int parentRows = 10;
		private int ChildRows = 30;
		private int GrandChildRows = 80;

		private DataTable GetParentTable()
		{
			DataTable dt = new DataTable("ParentTable");

			dt.Columns.Add(new DataColumn("parentID")); //lower case p
			dt.Columns.Add(new DataColumn("ParentName"));

			for(int i = 0; i < parentRows; ++i)
			{
				DataRow dr = dt.NewRow();
				dr[0] = i.ToString();
				dr[1] = string.Format("parentName{0}", i);
				dt.Rows.Add(dr);
			}

			return dt;
		}

		private Random r = new Random();

		private DataTable GetChildTable()
		{
			DataTable dt = new DataTable("ChildTable");

			dt.Columns.Add(new DataColumn("childID")); //lower case c
			dt.Columns.Add(new DataColumn("Name"));
			dt.Columns.Add(new DataColumn("ParentID")); //upper case P
			
			for(int i = 0; i < ChildRows; ++i)
			{
				DataRow dr = dt.NewRow();
				dr[0] = i.ToString();
				dr[1] = string.Format("ChildName{0}",i);
				dr[2] = r.Next(parentRows).ToString();//(i % parentRows).ToString();
				dt.Rows.Add(dr);
			}
		
			return dt;
		}

		private DataTable GetGrandChildTable()
		{
			DataTable dt = new DataTable("GrandChildTable");

			dt.Columns.Add(new DataColumn("GrandChildID"));
			dt.Columns.Add(new DataColumn("Name"));
			dt.Columns.Add(new DataColumn("ChildID")); //upper case C
			
			for(int i = 0; i < GrandChildRows; ++i)
			{
				DataRow dr = dt.NewRow();
				dr[0] = i.ToString();
				dr[1] = string.Format("GrandChildName{0}",i);
				dr[2] = r.Next(ChildRows).ToString();//(i % ChildRows).ToString();
				dt.Rows.Add(dr);
			}
			
			return dt;
		}

		#endregion

		private void gridGroupingControl1_TableControlMoveCurrentCellDirection(object sender, GridTableControlMoveCurrentCellDirectionEventArgs e)
		{
			GridTableCellStyleInfo style = e.TableControl.Model[e.Inner.RowIndex, e.Inner.ColIndex];
			int lastPos = style.TableCellIdentity.Table.TableDescriptor.VisibleColumns.Count - 1;
			string lastName = style.TableCellIdentity.Table.TableDescriptor.VisibleColumns[lastPos].Name;

			if( style.TableCellIdentity.TableCellType != GridTableCellType.AddNewRecordFieldCell )
			{
				if(style.TableCellIdentity.Column.MappingName == lastName && e.Inner.Direction == GridDirectionType.Right)
				{
					GridRecordRow recRow = style.TableCellIdentity.DisplayElement as GridRecordRow;

					if(recRow != null)
					{
						if( !recRow.ParentRecord.IsExpanded )
						{
							GridRecord rec = recRow.ParentRecord as GridRecord;
						
							int RecordCount = style.TableCellIdentity.Table.FilteredRecords.Count - 1;
							int index = style.TableCellIdentity.Table.FilteredRecords.IndexOf(rec);
						
							if( rec.ParentChildTable != null && rec.ParentChildTable.ParentNestedTable != null )
							{
								#region ChildTable Navigation
								Record ParentRecord = rec.ParentChildTable.ParentNestedTable.ParentRecord;    
							
								if( ParentRecord != null && ParentRecord.NestedTables.Count > 0 )   
								{
									int DisplayRecordCount = ParentRecord.NestedTables[0].FilteredRecords.Count;  
									int iindex = ParentRecord.NestedTables[0].FilteredRecords.IndexOf(rec); 

									
									if(iindex < DisplayRecordCount -1 )
									{
										#region /////Within ChildTableNavigation
										rec = ParentRecord.NestedTables[0].FilteredRecords[iindex + 1] as GridRecord;
										rec.SetCurrent(style.TableCellIdentity.Table.TableDescriptor.VisibleColumns[0].Name);
										e.Inner.Handled = true;
                                        e.Inner.Result = true;
										#endregion
									}
									else
									{
										#region /////ChildTable To ParenTableNavigation//////
										Table table = ParentRecord.ParentTable ; 
										iindex = table.FilteredRecords.IndexOf(ParentRecord);  
										if( iindex < table.FilteredRecords.Count - 1)
										{
											rec = table.FilteredRecords[iindex + 1] as GridRecord;
											Console.WriteLine(rec); 
											rec.SetCurrent((sender as GridGroupingControl).GetTableDescriptor(table.ParentTableDescriptor.Name).VisibleColumns[0].Name);
										}
										e.Inner.Handled = true;
										e.Inner.Result = true;
										#endregion
										
									}

								}
								#endregion
							}
							else if(index < RecordCount )
							{
								#region ///MainTable Navigation........
								rec = style.TableCellIdentity.Table.FilteredRecords[index + 1] as GridRecord;
								rec.SetCurrent(style.TableCellIdentity.Table.TableDescriptor.VisibleColumns[0].Name);
								e.Inner.Handled = true;
								e.Inner.Result = true;
								#endregion
							}
							
						}
						else
						{
							#region  ///ParentTable To ChildTable Navigation......
							NestedTable table = recRow.ParentRecord.NestedTables[0]; 
							Record rec = table.FilteredRecords[0]; 
							int index = table.FilteredRecords.IndexOf(rec);  
							rec.SetCurrent((sender as GridGroupingControl).GetTableDescriptor(table.ParentTableDescriptor.Name).VisibleColumns[0].Name);
							e.Inner.Handled = true;
							e.Inner.Result = true;
							#endregion
						}

					}
				}
			}
		}
	}
}
